Package ghidra.app.util.bin.format.som

# Class SomExecAuxHeader

java.lang.Object
ghidra.app.util.bin.format.som.SomAuxHeader
ghidra.app.util.bin.format.som.SomExecAuxHeader

All Implemented Interfaces:
  `StructConverter`

public class SomExecAuxHeader extends SomAuxHeader
Represents a SOM `som_exec_auxhdr` structure

See Also:
  - The 32-bit PA-RISC Run-time Architecture Document

- ## Field Summary

  ### Fields inherited from class ghidra.app.util.bin.format.som.SomAuxHeader

  `auxId`

  ### Fields inherited from interface ghidra.app.util.bin.StructConverter

  `ASCII, BYTE, DWORD, IBO32, IBO64, POINTER, QWORD, SLEB128, STRING, ULEB128, UTF16, UTF8, VOID, WORD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SomExecAuxHeader(BinaryReader reader)`
  Creates a new `SomExecAuxHeader`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `long`
  `getExecBssFill()`
  Returns BSS initialization value.
  `long`
  `getExecBssSize()`
  Returns the uninitialized data (BSS) size in bytes.
  `long`
  `getExecDataFile()`
  Returns the location of data in file.
  `long`
  `getExecDataMem()`
  Returns the offset of data in memory.
  `long`
  `getExecDataSize()`
  Returns the initialized data size in bytes.
  `long`
  `getExecEntry()`
  Returns the offset of entrypoint.
  `long`
  `getExecFlags()`
  Returns the loader flags.
  `long`
  `getExecTextFile()`
  Returns the location of text in file.
  `long`
  `getExecTextMem()`
  Returns the offset of text in memory.
  `long`
  `getExecTextSize()`
  Returns the text size in bytes.
  `DataType`
  `toDataType()`
  Returns a structure datatype representing the contents of the implementor of this interface.

  ### Methods inherited from class ghidra.app.util.bin.format.som.SomAuxHeader

  `getAuxId, getLength`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### SomExecAuxHeader

    public SomExecAuxHeader(BinaryReader reader) throws IOException
    Creates a new `SomExecAuxHeader`
    Parameters:
      `reader` - A `BinaryReader` positioned at the start of the auxiliary header
    Throws:
      `IOException` - if there was an IO-related error

- ## Method Details

  - ### getExecTextSize

    public long getExecTextSize()
    Returns the text size in bytes.
    Returns:
      the text size in bytes

  - ### getExecTextMem

    public long getExecTextMem()
    Returns the offset of text in memory.
    Returns:
      the offset of text in memory

  - ### getExecTextFile

    public long getExecTextFile()
    Returns the location of text in file.
    Returns:
      the location of text in file

  - ### getExecDataSize

    public long getExecDataSize()
    Returns the initialized data size in bytes.
    Returns:
      the initialized data size in bytes

  - ### getExecDataMem

    public long getExecDataMem()
    Returns the offset of data in memory.
    Returns:
      the offset of data in memory

  - ### getExecDataFile

    public long getExecDataFile()
    Returns the location of data in file.
    Returns:
      the location of data in file

  - ### getExecBssSize

    public long getExecBssSize()
    Returns the uninitialized data (BSS) size in bytes.
    Returns:
      the uninitialized data (BSS) size in bytes

  - ### getExecEntry

    public long getExecEntry()
    Returns the offset of entrypoint.
    Returns:
      the offset of entrypoint

  - ### getExecFlags

    public long getExecFlags()
    Returns the loader flags.
    Returns:
      the loader flags

  - ### getExecBssFill

    public long getExecBssFill()
    Returns BSS initialization value.
    Returns:
      BSS initialization value

  - ### toDataType

    public DataType toDataType() throws DuplicateNameException, IOException
    Description copied from interface: `StructConverter`
    Returns a structure datatype representing the contents of the implementor of this interface.

    For example, given:

         class A {
             int foo;
             double bar;
         }

    The return value should be a structure data type with two data type components; an INT and a DOUBLE. The structure should contain field names and, if possible, field comments.

    Specified by:
      `toDataType` in interface `StructConverter`
    Specified by:
      `toDataType` in class `SomAuxHeader`
    Returns:
      returns a structure datatype representing the implementor of this interface
    Throws:
      `DuplicateNameException` - when a datatype of the same name already exists
      `IOException` - if an IO-related error occurs
    See Also:
      - `StructureDataType`